/***********************************************************************************************************************
 *
 * blueBill Mobile - Android - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile
 * SCM: https://kenai.com/hg/bluebill~android-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.news;

import javax.annotation.Nonnull;
import javax.swing.Action;
import it.tidalwave.util.thread.ThreadType;
import it.tidalwave.util.thread.annotation.ThreadConfined;

/***********************************************************************************************************************
 *
 * @stereotype Controller
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public interface NewsViewController
  {
    /*******************************************************************************************************************
     *
     * Loads the news feed in background, from the cache or from the network.
     *
     ******************************************************************************************************************/
    @Nonnull @ThreadConfined(type=ThreadType.ANY)    
    public void loadNewsFeed();

    /*******************************************************************************************************************
     *
     * The user cancelled the wait while preparing the news.
     *
     ******************************************************************************************************************/
    @ThreadConfined(type=ThreadType.ANY) 
    public void cancelLoading();
    
    /*******************************************************************************************************************
     *
     * Gets the Action for marking all messages as read.
     *
     ******************************************************************************************************************/
    @Nonnull @ThreadConfined(type=ThreadType.ANY) 
    public Action getMarkAllMessagesAsReadAction();
  }
